#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
 #include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

#define PIN        8
#define NUMPIXELS 10
#define CPLAY_LIGHTSENSOR A8
#define CPLAY_LEFTBUTTON 4        ///< left button pin
#define CPLAY_RIGHTBUTTON 19      ///< right button pin

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

uint32_t pillColor[] = {pixels.Color(255,20,147), pixels.Color(255,69,0), pixels.Color(0, 0, 255)};
int pillPixel[] = {0,0,0};
int lastValue[] = {0,0,0};
int startPixels[] = {0,4,7};


BLYNK_WRITE(V0)
{
  int pinValue = param.asInt(); 
  int pillID = 0;
  setPillPixels(pillID, pinValue);
}

BLYNK_WRITE(V1)
{
  int pinValue = param.asInt(); 
  int pillID = 1;
  setPillPixels(pillID, pinValue);
}


BLYNK_WRITE(V3)
{
  int pinValue = param.asInt(); 
  int pillID = 2;
  setPillPixels(pillID, pinValue);
}


boolean leftButtonPressed() {
  return digitalRead(CPLAY_LEFTBUTTON);
}


void initializePixels(){
  pixels.begin();
}

void neoPixelOn(int pillID){
  for(int j=0; j<pillPixel[pillID];j++){
    pixels.setPixelColor(startPixels[pillID] + j, pillColor[pillID]);
  }
  pixels.show();
}


void neoPixelsOff(int pillID, int amount){
  for(int i=0; i<amount; i++) { // For each pixel...
    pixels.setPixelColor(i + startPixels[pillID], pixels.Color(0, 0, 0));
  }
  pixels.show();
}

void setAllPixelsOff(){
  for(int i=0; i< 3; i++){
    setPillPixels(i, 0);
  }
  Blynk.virtualWrite(V0,0);
  Blynk.virtualWrite(V1,0);
  Blynk.virtualWrite(V3,0);
}

void setPillPixels(int pillID, int pinValue){
   int diff = lastValue[pillID] - pinValue;
  if( diff > 0){
    neoPixelsOff(pillID, diff);
  }
  else{

     pillPixel[pillID] = pinValue;
     neoPixelOn(pillID);
  }
  lastValue[pillID]= pinValue;
}
